#pragma once

#include "CoreMinimal.h"
#include "ItemAddon.h"
#include "Templates/SubclassOf.h"
#include "Engine/CollisionProfile.h"
#include "GuardAddedProxy.h"
#include "Engine/HitResult.h"
#include "K30Addon18.generated.h"

class UStatusEffect;
class ASurvivor;
class UPrimitiveComponent;
class AActor;

UCLASS(Blueprintable, Abstract, meta=(BlueprintSpawnableComponent))
class UK30Addon18 : public UItemAddon
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UStatusEffect> _overlapStatusEffectClass;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _lifetimePostApplication;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FCollisionProfileName _collisionProfileName;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FGuardAddedProxy _guardAddedProxy;

	UPROPERTY(BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	TMap<ASurvivor*, UStatusEffect*> _appliedStatusEffects;

private:
	UFUNCTION(BlueprintCallable)
	void Authority_OnSplineEndOverlap(UPrimitiveComponent* overlappedComponent, AActor* otherActor, UPrimitiveComponent* otherComp, int32 otherBodyIndex);

	UFUNCTION()
	void Authority_OnSplineBeginOverlap(UPrimitiveComponent* overlappedComponent, AActor* otherActor, UPrimitiveComponent* otherComp, int32 otherBodyIndex, bool bFromSweep, const FHitResult& sweepResult);

public:
	UK30Addon18();
};

FORCEINLINE uint32 GetTypeHash(const UK30Addon18) { return 0; }
